#include "smtp.h"

extern smtpi jtin;


void smtp_offline_mtq(void *arg)
   {
   smtp_tu par_o= (smtp_tu) arg;
   xmlnode loOffline,loMessage;
   char *lcOffline,*lcBFile;
   int lii;
   struct dirent   *dirp;
   struct DIR      *dp;

   smtpp par;
   jpacket jp;
   pool p;

   // check all offline jabber message
   if (jtin->tmpOfflineJabber==1)
      {
      loOffline=xmlnode_get_tag(jtin->config,"jabber/offline");
      if ((lcOffline=xmlnode_get_attrib(loOffline,"folder")   )==NULL)
         lcOffline= pstrdup(par_o->p,SMTP_OFFLINEJABBER_FOLDER);

      if ((dp = opendir(lcOffline)) != NULL)
         {
         lii=0;
         while ( (dirp = readdir((DIR *)dp)) != NULL)
               {
               if (strcmp(dirp->d_name, ".") == 0  ||
                   strcmp(dirp->d_name, "..") == 0)
                   continue;      // ignore dot and dot-dot

 
               // load jabber message from file
               // and send it to out_message...
               lcBFile=spools(par_o->p,lcOffline,"/",dirp->d_name,par_o->p);
               if ((loMessage=xmlnode_file(lcBFile))!=NULL)
                  {
                  remove(lcBFile);

                  p=pool_new();   
                  par= smtp_param_i(p,jtin->i);
                  pool_cleanup(par->tmppool, smtp_out_Xcleanup, (void *)par);
                  jp = pmalloc(p,sizeof(_jpacket));

                  jp->x = loMessage;
                  jp=par->jp = jpacket_reset(jp);
                  jpacket_subtype(jp);

                  smtp_out_packets_message(par,(char *) NULL);
                  }

               lii++;
               }
 
         closedir((DIR *)dp);
         }
      }

   pool_free(par_o->p);
   }




// create new thread for sending offline messages
result smtp_offline_daemon(void *arg)
   {
   pool p=pool_new();
   smtp_tu par_o;

   par_o=pmalloco(p, sizeof(_smtp_tu));
   par_o->p=p;
   par_o->index=(int *) arg;

   par_o->q=mtq_new(p);
   mtq_send(par_o->q, p, smtp_offline_mtq, (void *)par_o);
   return r_DONE;
   }
