#include "smtp.h"
extern smtpi jtin;

// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_presence(smtpp par,char *type)
   {
   int liProcess=0,liCount;
   jpacket jp=par->jp;
   smtp_jq loQueue;
   char *lcTo=NULL;

   switch(jp->subtype)
      {
      case JPACKET__AVAILABLE:
           loQueue=smtp_NewQueueItem(par->tmppool);
           loQueue->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           xmlnode_insert_cdata(xmlnode_insert_tag(loQueue->x,"status"),"Online",-1);

           if (j_strlen(jp->to->user)>0)
              lcTo=xmlnode_get_attrib(jp->x,"to");

           liCount=smtp_online_add_item(par->tmppool, smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")),lcTo);
           jtin->CoreContactsOnline+=liCount;
           smtp_StatsSetDelta("CoreContactsOnline", liCount);

		   liProcess=1;
           break;

      case JPACKET__UNAVAILABLE:
           loQueue=smtp_NewQueueItem(par->tmppool);
           loQueue->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           xmlnode_put_attrib(loQueue->x,"type","unavailable");

           if (j_strlen(jp->to->user)>0)
              lcTo=xmlnode_get_attrib(jp->x,"to");

           liCount=smtp_online_remove_item(par->tmppool, smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")),lcTo);
           jtin->CoreContactsOnline-=liCount;
           smtp_StatsSetDelta("CoreContactsOnline", -1*liCount);

           liProcess=1;
           break;

      case JPACKET__PROBE:
           loQueue=smtp_NewQueueItem(par->tmppool);
           loQueue->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           xmlnode_insert_cdata(xmlnode_insert_tag(loQueue->x,"status"),"Online",-1);

           if (j_strlen(jp->to->user)>0)
              lcTo=xmlnode_get_attrib(jp->x,"to");

           liCount=smtp_online_add_item(par->tmppool, smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")), lcTo);
           jtin->CoreContactsOnline+=liCount;
           smtp_StatsSetDelta( "CoreContactsOnline",liCount);
           liProcess=1;
           break;

      case JPACKET__ERROR:
           break;

      case JPACKET__INVISIBLE:
           break;
      }


   if (liProcess==1)
      smtp_FlushQueue(par->i, loQueue);


   return liProcess;
   }
// E:2005-08-29 gorila@dione.zcu.cz
